import axios from "axios";

export default {
  fetchProductData({ commit }) {
    axios
      .get("http://localhost:3000/products")
      .then((response) => {
        commit("setProductList", response.data);
      })
      .catch((e) => {
        console.log(e);
      });
  },
  toggleSingleExpand({ commit }) {
    commit("setSingleExpand");
  },

  closeDialog({ commit }) {
    commit("setDialog", false);
  },

  deleteProduct({ dispatch }, idList) {
    confirm("Are you sure you want to delete this item?") &&
      idList.forEach((id) => {
        axios
          .delete(`http://localhost:3000/products/${id}`)
          .then(() => {
            dispatch("fetchProductData");
          })
          .catch((e) => {
            console.log(e);
          });
      });
    this.itemList = [];
  },
  deleteMultiProduct({ dispatch }, items) {
    const itemList = [];
    items.forEach((item) => {
      itemList.push(item.id);
    });
    console.log(itemList);
    dispatch("deleteProduct", itemList);
  },

  saveProduct({ getters, dispatch }) {
    if (!getters.editedItem.image) {
      getters.editedItem.image =
        "https://upload.wikimedia.org/wikipedia/commons/7/70/Solid_white.svg";
    }
    const postConfig = {
      method: "post",
      url: `http://localhost:3000/products/`,
      data: getters.editedItem,
    };
    const putConfig = {
      method: "put",
      url: `http://localhost:3000/products/${getters.editedItem.id}`,
      data: getters.editedItem,
    };
    axios(!getters.editedItem.id ? postConfig : putConfig).then(() => {
      dispatch("fetchProductData");
    });
    dispatch("closeDialog");
  },

  editProduct({ commit, getters }, item) {
    commit("setEditedIndex", getters.productList.indexOf(item));
    commit("setEditedItem", Object.assign({}, item));
    commit("setDialog", true);
  },
};
